#INCLUDE "diamp_pdm_md.h"

*************************************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_DIAMP_PDM_MD",lcCollate)


***********************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_DIAMP_PDM_MD_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_DIAMP_PDM_MD_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)


*******************************************************
DEFINE CLASS _DIAMP_PDM_MD AS _pdm_PlugIn && 
   Name="_DIAMP_PDM_MD"

   ID=5         && ID of Plug-in
   Type="DIAMP" && Typ of plug-in (group)
   Alias=""     && Alias for table with meta data

*!*	   ShareMode=_PDM_SM_Share
*!*	   ShareGroup=5

   ShareMode=_PDM_SM_None
   ShareGroup=0


   Setting=.NULL.
   Par=.NULL.

   oParser=.NULL.    && Object reference to parser object
   iXMLDataFailed=PI_valXMLFailed
   CPEM=""

   DIME aImgs(4)

   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE GetDescription() && Return Description of Plug-in
      RETURN This.GetString(PI_Description)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Load basic FXP library for parsing
      IF ATC("_DIAMP",SET("PROCEDURE"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET PROCED TO (lcPath+"_DIAMP.prg") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load basic VCX library for GUI
      IF ATC(lcFile+".VCX",SET("CLASSLIB"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+".vcx") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load localize VCX library
      IF !lcGUILang=="en" AND ATC(lcFile+"_"+lcGUILang+".VCX",SET("CLASSLIB"))=0
         luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+"_"+lcGUILang+".vcx") ADDITIVE
         =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
      ENDIF

      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\MD_"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         llEn=.F.
         SELE (This.ALTab)
         SET ORDER TO "I01"
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "Visual FoxPro - PDM (Meta data)")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetCSS, "CSS File")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetJS, "JS File")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetMD, "Metadata File")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valXMLFailed,"XML Data are invalid: PI-%ID% %File% %CPEM%.")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Description, [Ukzkov plug-in pro generovn roziujcho popisu metod, procedur a funkc z metadat ve zdrojovm kdu nebo extern tabulce.])
         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
   ENDPROC

   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      LOCAL loPDMs,lii,lcHTML,;
            lcMethod,liParams,liSeeAlso,lcPom,;
            lcParams,lcFile,lcClass,loObj,llDal,loPDM,lcCMS,lcCME

      LOCAL ARRAY laSection(8),laData(1),laOut(1)
      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)

      This.Setting=loSetting
      This.Par=loPar

      lcCMS=m.loPDM.aCF(1).GetTag("Comment",_PDM_SC_BT)
      lcCME=m.loPDM.aCF(1).GetTag("Comment",_PDM_SC_ET)
      
      IF ISNULL(This.oParser)
         This.oParser=CREATEOBJECT("__DIAMP_PDM")
      ENDIF

      This.oParser.PI=This

      lcMethod=loPar.cPEM

      IF !USED(This.Alias)
         lcSource=loPar.Ram.XXDESC
      ELSE
         lcClass=UPPER(loPar.cParent)
         lcFile=UPPER(loPar.File)
         SELE (This.Alias)
         LOCATE FOR UPPER(CLASSLOC)==lcFile AND ;
                    UPPER(CLASS)==lcClass AND ;
                    UPPER(OBJNAME)==UPPER(lcMethod)

         IF !FOUND()
            lcFile=ExtractFileFromFile(lcFile)
            LOCATE FOR UPPER(CLASSLOC)==lcFile AND ;
                       UPPER(CLASS)==lcClass AND ;
                       UPPER(OBJNAME)==UPPER(lcMethod)
         ENDIF

         lcSource=IIF(!FOUND() OR EMPTY(ALLT(HTML)),loPar.Ram.XXDESC,HTML)
      ENDIF

      llDal=.T.
      lcHTML=""

      IF EMPTY(ALLT(lcSource))
         llDal=.F.
      ELSE
         This.CPEM=IIF(EMPTY(loPar.cParent),"",loPar.cParent+".")+loPar.cPEM
      
         STORE 0 TO liParams,liSeeAlso,This.oParser.SeeCount
         STORE "" TO lcParams

         laSection(1)="descr"
         laSection(2)="parameters"
         laSection(3)="retval"
         laSection(4)="remarks"
         laSection(5)="example"
         laSection(6)="seealso"
         laSection(7)="copyright"
         laSection(8)="appliesto"

         llDal=This.oParser.ParseTextEx(@lcSource,@laSection,@laData)
      ENDIF


      IF llDal AND !ISNULL(laData(1)) AND LEN(STRTRAN(laData(1),CRLF,""))>0
         lcHTML=lcHTML+;
                [<!-- Descr Begin -->]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+[<div class="diamp_pdm_md_descr">]+m.loPDM.aSpace(21)+;
                laData(1)+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+"</div>"+m.loPDM.aSpace(21)+;
                "<!-- Descr End -->"+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)
      ENDIF

      IF llDal AND !ISNULL(laData(2)) AND laData(2).ControlCount>0
         lcHTML=lcHTML+;
                "<!-- Syntax Begin -->"+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+"<div class='diamp_pdm_md_syntax'>"+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+"<div>"+lcMethod+"(</div>"+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(3)+"<table>"+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(4)+"<tbody>"+m.loPDM.aSpace(21)
                
         lcParams="<!-- Parameters Begin -->"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"<div class='diamp_pdm_md_params'>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+[<div class="diamp_pdm_md_head">]+This.GetHTMLString(PI_HTML_Params)+[</div>]+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<dl class="diamp_pdm_md_DIAMP">'+m.loPDM.aSpace(21)

         liParams=laData(2).ControlCount
         FOR lii=1 TO liParams
             loObj=laData(2).Controls(lii)
             lcHTML=lcHTML+;
                    m.loPDM.aSpace(5)+[<tr><td>]+IIF(loObj.byref="1","@","&nbsp;")+;
                    [</td><td class="COL1">]+loObj.xname+"</td><td>"+;
                    loObj.Type+[</td><td class="COL4">]+m.lcCMS+loObj.caption+m.lcCME+"</td></tr>"+m.loPDM.aSpace(21)



             lcParams=lcParams+;
                    m.loPDM.aSpace(3)+"<dt><i>"+loObj.xname+"</i>"+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(4)+"<dd>"+"["+loObj.direction+"] "+loObj.description+m.loPDM.aSpace(21)

         NEXT
         lcParams=lcParams+m.loPDM.aSpace(2)+"</dl>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+"</div>"+m.loPDM.aSpace(21)+;
                  "<!-- Parameters End -->"+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)

         lcHTML=lcHTML+;
                m.loPDM.aSpace(4)+"</tbody>"+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(3)+"</table>"+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+"<div>)</div>"+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+"</div>"+m.loPDM.aSpace(21)+;
                "<!-- Syntax End -->"+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)
      ELSE
         IF llDal
            lcHTML=lcHTML+m.loPDM.aSpace(21)+;
                   "<!-- Syntax -->"+m.loPDM.aSpace(21)+;
                   m.loPDM.aSpace(1)+"<div class='diamp_pdm_md_syntax'>"+m.loPDM.aSpace(21)+;
                   m.loPDM.aSpace(2)+"<div>"+lcMethod+"()</div>"+m.loPDM.aSpace(21)+;
                   m.loPDM.aSpace(1)+"</div>"+m.loPDM.aSpace(21)+;
                   "<!-- Syntax End -->"+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)
         ENDIF
      ENDIF

      IF llDal AND !ISNULL(laData(3)) AND LEN(STRTRAN(laData(3),CRLF,""))>0
         lcHTML=lcHTML+;
                [<!-- Returns Begin -->]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+[<div class="diamp_pdm_md_retval">]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[<div class="diamp_pdm_md_head">]+This.GetHTMLString(PI_HTML_Return)+[</div>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[<div class="diamp_pdm_md_body">]+laData(3)+"</div>"+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+"</div>"+m.loPDM.aSpace(21)+;
                "<!-- Returns End -->"+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)
      ENDIF

      IF llDal AND liParams>0
         lcHTML=lcHTML+lcParams
      ENDIF

      IF llDal AND !ISNULL(laData(4)) AND LEN(STRTRAN(laData(4),CRLF,""))>0
         lcHTML=lcHTML+;
                [<!-- Remarks Begin -->]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+[<div class="diamp_pdm_md_remarks">]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[<div class="diamp_pdm_md_head">]+This.GetHTMLString(PI_HTML_Remarks)+[</div>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[<div class="diamp_pdm_md_body">]+laData(4)+"</div>"+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+"</div>"+m.loPDM.aSpace(21)+;
                "<!-- Remarks End -->"+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)
      ENDIF

      IF llDal AND !ISNULL(laData(5)) AND LEN(STRTRAN(laData(5),CRLF,""))>0
         lcHTML=lcHTML+;
                [<!-- Example Begin -->]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+[<div class="diamp_pdm_md_example">]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[<div class="diamp_pdm_md_head">]+This.GetHTMLString(PI_HTML_Example)+[</div>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[<div class="diamp_pdm_md_body">]+laData(5)+;
                m.loPDM.aSpace(2)+"</div>"+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+"</div>"+m.loPDM.aSpace(21)+;
                "<!-- Example End -->"+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)
      ENDIF


      IF llDal AND !ISNULL(laData(6)) AND laData(6).ControlCount>0
         lcHTML=lcHTML+;
                [<!-- SeeAlso Begin -->]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+[<div class="diamp_pdm_md_seealso">]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[<div class="diamp_pdm_md_head">]+This.GetHTMLString(PI_HTML_SeeAlso)+[</div>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[<div class="diamp_pdm_md_body"> <!-- Body Begin -->]+m.loPDM.aSpace(21)

                
         liSeeAlso=laData(6).ControlCount
         FOR lii=1 TO liSeeAlso
             This.oParser.SeeCount=This.oParser.SeeCount+1
             lcHTML=lcHTML+;
                    This.ConvertSee2HTML(loPar.File,laData(6).Controls(lii).metadata,UPPER(lcMethod)+"_"+LTRIM(STR(This.oParser.SeeCount,11)),lii=liSeeAlso)
         NEXT
         lcHTML=lcHTML+m.loPDM.aSpace(2)+"</div> <!-- Body End -->"+m.loPDM.aSpace(21)


         IF !ISNULL(laData(8)) AND (laData(8).ControlCount>0 OR laData(8).Tag="1")
            * Auto detection of Appliesto
            IF laData(8).Tag="1"
               liSeeAlso=loPDMs.GetMPAnchors(@laOut,"",lcMethod,"../../")
               FOR lii=liSeeAlso TO 1 STEP -1
                   IF UPPER(loPar.File)==UPPER(laOut(lii,2)) AND lcClass==UPPER(laOut(lii,3))
                      =ADEL(laOut,lii)
                      liSeeAlso=liSeeAlso-1
                      LOOP
                   ENDIF
                   IF EMPTY(laOut(lii,3))
                      * Read Anchor for file
                      laOut(lii,1)=ExtractFileFromFile(laOut(lii,2))
                      laOut(lii,2)=loPDMs.GetAnchor(laOut(lii,2),"../../")
                   ELSE
                      * Read Anchor for class
                      laOut(lii,1)=ExtractFileFromFile(laOut(lii,3))
                      laOut(lii,2)=loPDMs.GetClassAnchor(laOut(lii,2),laOut(lii,3),"../../")
                   ENDIF
               NEXT
            ELSE
               liSeeAlso=laData(8).ControlCount
            ENDIF

            IF liSeeAlso>0
               lcHTML=lcHTML+m.loPDM.aSpace(21)+;
                      [<!-- Appliesto Begin -->]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+[<div class="diamp_pdm_md_appliesto">]+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+[<span class="diamp_pdm_md_head diamp_pdm_md_appliesto_head">]+This.GetHTMLString(PI_HTML_Appliesto)+[</span>]+m.loPDM.aSpace(21)

               IF laData(8).Tag="1"
                  DIME laOut(liSeeAlso,4)
                  FOR lii=1 TO liSeeAlso
                      This.oParser.SeeCount=This.oParser.SeeCount+1
                      lcHTML=lcHTML+;
                             This.ConvertSeeEx2HTML(@laOut,UPPER(lcMethod)+"_"+LTRIM(STR(This.oParser.SeeCount,11)),lii=liSeeAlso)
                  NEXT
               ELSE
                  FOR lii=1 TO liSeeAlso
                      This.oParser.SeeCount=This.oParser.SeeCount+1
                      lcHTML=lcHTML+;
                             This.ConvertSee2HTML(loPar.File,laData(8).Controls(lii).metadata,UPPER(lcMethod)+"_"+LTRIM(STR(This.oParser.SeeCount,11)),lii=liSeeAlso)
                  NEXT
               ENDIF

               lcHTML=lcHTML+m.loPDM.aSpace(2)+"</div>"+m.loPDM.aSpace(21)+"<!-- Appliesto End -->"+m.loPDM.aSpace(21)
            ENDIF
         ENDIF

         lcHTML=lcHTML+m.loPDM.aSpace(1)+"</div>"+m.loPDM.aSpace(21)+;
                "<!-- SeeAlso End -->"+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)
      ENDIF

      IF llDal AND !ISNULL(laData(7)) AND LEN(STRTRAN(laData(7),CRLF,""))>0
         lcHTML=lcHTML+;
                [<!-- CopyRight Begin -->]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+[<div class="diamp_pdm_md_copyright">]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+[<hr />]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+[<div class="diamp_pdm_md_body"> <!-- Body Begin -->]+m.loPDM.aSpace(21)+;
                laData(7)+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(2)+"</div> <!-- Body End -->"+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+"</div>"+m.loPDM.aSpace(21)+;
                "<!-- CopyRight End -->"+m.loPDM.aSpace(21)

      ENDIF

      lcHTML=lcHTML+[</div>]+m.loPDM.aSpace(21)

      STORE .NULL. TO This.Setting,This.Par,This.oParser.PI

      RETURN lcHTML
   ENDPROC

   PROCEDURE GetScript()
      RETURN []
*!*	      RETURN [<script language="JavaScript" type="text/javascript">]+CRLF+;
*!*	             [var pcLastLNK=pcLast=pcLNK="";]+CRLF+;
*!*	             [document.onclick=BodyClick; // Global handler Click]+CRLF+;
*!*	             [</script>]+CRLF

   ENDPROC

   PROCEDURE ConvertSee2HTML(lcFile,lcSee,lcID,llLast)
      * lcFile  - 
      * lcSee   - Meta data odkazu
      * lcTitle - Titulek odkazu
      * lcID    - Index
      * llLast  - 

      LOCAL ARRAY laOut(1)
      This.oParser.ConvertSee2HTML(@lcFile,@lcSee,@laOut)
      RETURN This.ConvertSeeEx2HTML(@laOut,@lcID,llLast)
   ENDPROC

   PROCEDURE ConvertSeeEx2HTML(laOut,lcID,llLast)
      *@laOut  - Array of linkes
      * lcID    - Index
      * llLast - 

      LOCAL lcHTML,lii,loPDMs,loPDM
      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)

      IF ALEN(laOut,1)=1
         lcHTML=IIF(EMPTY(laOut(1,2)),laOut(1,1),;
                m.loPDM.aSpace(3)+[<a class="diamp_pdm_md_see" href="]+laOut(1,2)+[" target="_blank" title="]+;
                STRTRAN(loPDMs.aStrings(;
                   IIF(BITTEST(laOut(1,4),_PDM_FG_bClass),PDM_02799,;
                   IIF(BITTEST(laOut(1,4),_PDM_FG_bMethod),PDM_04726,;
                   IIF(BITTEST(laOut(1,4),_PDM_FG_bProperty),PDM_04653,PDM_05049)))),"%name%",laOut(1,1))+;
                [">]+laOut(1,1)+[</a>])+IIF(!llLast," | ","")+m.loPDM.aSpace(21)
      ELSE
         This.Par.lLNK=.T.
         lcHTML=m.loPDM.aSpace(3)+[<span id="SPN_]+lcID+[" class="diamp_pdm_md_collaborative" onclick="pcLNK=']+lcID+[';">]+laOut(1,1)+"</span>"+IIF(!llLast," | ","")+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(3)+[<div id="LNK_]+lcID+[" class="diamp_pdm_md_link_tab"> <!-- Link Table Begin -->]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(4)+[<table>]+m.loPDM.aSpace(21)
         
         FOR lii=1 TO ALEN(laOut,1)
             lcHTML=lcHTML+;
                    m.loPDM.aSpace(5)+[<tr><td><a class="diamp_pdm_md_see" href="]+laOut(lii,2)+[" target="_blank" title="]+;
                    STRTRAN(loPDMs.aStrings(;
                       IIF(BITTEST(laOut(lii,4),_PDM_FG_bClass),PDM_02799,;
                       IIF(BITTEST(laOut(lii,4),_PDM_FG_bMethod),PDM_04726,;
                       IIF(BITTEST(laOut(lii,4),_PDM_FG_bProperty),PDM_04653,PDM_05049)))),"%name%",laOut(lii,3))+;
                    [">]+laOut(lii,3)+[</a></td></tr>]+m.loPDM.aSpace(21)
         NEXT

         lcHTML=lcHTML+;
                m.loPDM.aSpace(4)+[</table>]+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(3)+[</div> <!-- Link Table End -->]+m.loPDM.aSpace(21)
      ENDIF
      RETURN lcHTML
   ENDPROC

   PROCEDURE ConvertNote2HTML(lcData)
      * lcData - 

      LOCAL loPDM
      loPDM=EVAL(This.PDM)
      RETURN m.loPDM.aSpace(21)+[<div class="diamp_pdm_md_note"><span class="diamp_pdm_md_note">]+;
             This.GetHTMLString(PI_HTML_Note)+[</span>]+lcData+[</div>]+m.loPDM.aSpace(21)
   ENDPROC

   PROCEDURE ConvertStop2HTML(lcData)
      * lcData - 
      LOCAL loPDM,lcPath,loObj,lcFile
      loPDM=EVAL(This.PDM)
      loObj=This.Par.oPDMx

      lcPath=loPDM.OutDir+loObj.OutDir+"\"+loObj.FileName+"\"
      RETURN m.loPDM.aSpace(21)+[<div class="diamp_pdm_md_nstop"><img src="]+;
             loPDM.PathRelativePathTo(lcPath,This.aImgs(PI_img_Stop))+;
             [" class="diamp_pdm_md_nstop"><div>]+;
             lcData+[</div></div>]+m.loPDM.aSpace(21)
   ENDPROC

   PROCEDURE ConvertQuest2HTML(lcData)
      * lcData - 
      LOCAL loPDM,lcPath,loObj,lcFile
      loPDM=EVAL(This.PDM)
      loObj=This.Par.oPDMx

      lcPath=loPDM.OutDir+loObj.OutDir+"\"+loObj.FileName+"\"
      RETURN m.loPDM.aSpace(21)+[<div class="diamp_pdm_md_nquestion"><img src="]+;
             loPDM.PathRelativePathTo(lcPath,This.aImgs(PI_img_Quest))+;
             [" class="diamp_pdm_md_nquestion"><div>]+;
             lcData+[</div></div>]+m.loPDM.aSpace(21)
   ENDPROC

   PROCEDURE ConvertExcla2HTML(lcData)
      * lcData - 
      LOCAL loPDM,lcPath,loObj,lcFile
      loPDM=EVAL(This.PDM)
      loObj=This.Par.oPDMx

      lcPath=loPDM.OutDir+loObj.OutDir+"\"+loObj.FileName+"\"
      RETURN m.loPDM.aSpace(21)+[<div class="diamp_pdm_md_nexclamation"><img src="]+;
             loPDM.PathRelativePathTo(lcPath,This.aImgs(PI_img_Excla))+;
             [" class="diamp_pdm_md_nexclamation"><div>]+;
             lcData+[</div></div>]+m.loPDM.aSpace(21)
   ENDPROC

   PROCEDURE ConvertInfo2HTML(lcData)
      * lcData - 
      LOCAL loPDM,lcPath,loObj,lcFile
      loPDM=EVAL(This.PDM)
      loObj=This.Par.oPDMx

      lcPath=loPDM.OutDir+loObj.OutDir+"\"+loObj.FileName+"\"
      RETURN m.loPDM.aSpace(21)+[<div class="diamp_pdm_md_ninformation"><img src="]+;
             loPDM.PathRelativePathTo(lcPath,This.aImgs(PI_img_Info))+;
             [" class="diamp_pdm_md_ninformation"><div>]+;
             lcData+[</div></div>]+m.loPDM.aSpace(21)
   ENDPROC



   PROCEDURE GetSetting() &&  Return settings object
      RETURN CREATEOBJECT("_DIAMP_PDM_MD_par")
   ENDPROC


   PROCEDURE Open(lcFile,loSettings) && Load settings
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      loSettings.xhtmlS=GetINIString(lcSection,"XHTMLS",loSettings.xhtmlS,254,@lcFile)
      loSettings.xhtmlE=GetINIString(lcSection,"XHTMLE",loSettings.xhtmlE,254,@lcFile)
      loSettings.SeeS=GetINIString(lcSection,"SEES",loSettings.SeeS,254,@lcFile)
      loSettings.SeeE=GetINIString(lcSection,"SEEE",loSettings.SeeE,254,@lcFile)
      loSettings.CodeS=GetINIString(lcSection,"CODES",loSettings.CodeS,254,@lcFile)
      loSettings.CodeE=GetINIString(lcSection,"CODEE",loSettings.CodeE,254,@lcFile)
      loSettings.ExprS=GetINIString(lcSection,"EXPRS",loSettings.ExprS,254,@lcFile)
      loSettings.ExprE=GetINIString(lcSection,"EXPRE",loSettings.ExprE,254,@lcFile)

      loSettings.noteS=GetINIString(lcSection,"NOTES",loSettings.noteS,254,@lcFile)
      loSettings.noteE=GetINIString(lcSection,"NOTEE",loSettings.noteE,254,@lcFile)
      loSettings.stopS=GetINIString(lcSection,"STOPS",loSettings.stopS,254,@lcFile)
      loSettings.stopE=GetINIString(lcSection,"STOPE",loSettings.stopE,254,@lcFile)
      loSettings.questS=GetINIString(lcSection,"QUESTS",loSettings.questS,254,@lcFile)
      loSettings.questE=GetINIString(lcSection,"QUESTE",loSettings.questE,254,@lcFile)
      loSettings.exclaS=GetINIString(lcSection,"EXCLAS",loSettings.exclaS,254,@lcFile)
      loSettings.exclaE=GetINIString(lcSection,"EXCLAE",loSettings.exclaE,254,@lcFile)
      loSettings.infoS=GetINIString(lcSection,"INFOS",loSettings.infoS,254,@lcFile)
      loSettings.infoE=GetINIString(lcSection,"INFOE",loSettings.infoE,254,@lcFile)

      loSettings.Source=GetINIString(lcSection,"Source",loSettings.Source,254,@lcFile)
      loSettings.CSS=GetINIString(lcSection,"CSS",loSettings.CSS,254,@lcFile)
      loSettings.JS=GetINIString(lcSection,"JS",loSettings.JS,254,@lcFile)

      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile,loSettings) && Save settings
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      =WriteINIString(lcSection,"XHTMLS",ALLT(loSettings.xhtmlS),@lcFile)
      =WriteINIString(lcSection,"XHTMLE",ALLT(loSettings.xhtmlE),@lcFile)
      =WriteINIString(lcSection,"SEES",ALLT(loSettings.SeeS),@lcFile)
      =WriteINIString(lcSection,"SEEE",ALLT(loSettings.SeeE),@lcFile)
      =WriteINIString(lcSection,"BYREF",ALLT(loSettings.ByRef),@lcFile)
      =WriteINIString(lcSection,"CODES",ALLT(loSettings.CodeS),@lcFile)
      =WriteINIString(lcSection,"CODEE",ALLT(loSettings.CodeE),@lcFile)
      =WriteINIString(lcSection,"EXPRS",ALLT(loSettings.ExprS),@lcFile)
      =WriteINIString(lcSection,"EXPRE",ALLT(loSettings.ExprE),@lcFile)

      =WriteINIString(lcSection,"NOTES",ALLT(loSettings.noteS),@lcFile)
      =WriteINIString(lcSection,"NOTEE",ALLT(loSettings.noteE),@lcFile)
      =WriteINIString(lcSection,"STOPS",ALLT(loSettings.stopS),@lcFile)
      =WriteINIString(lcSection,"STOPE",ALLT(loSettings.stopE),@lcFile)
      =WriteINIString(lcSection,"QUESTS",ALLT(loSettings.questS),@lcFile)
      =WriteINIString(lcSection,"QUESTE",ALLT(loSettings.questE),@lcFile)
      =WriteINIString(lcSection,"EXCLAS",ALLT(loSettings.exclaS),@lcFile)
      =WriteINIString(lcSection,"EXCLAE",ALLT(loSettings.exclaE),@lcFile)
      =WriteINIString(lcSection,"INFOS",ALLT(loSettings.infoS),@lcFile)
      =WriteINIString(lcSection,"INFOE",ALLT(loSettings.infoE),@lcFile)

      =WriteINIString(lcSection,"Source",ALLT(loSettings.Source),@lcFile)
      =WriteINIString(lcSection,"CSS",ALLT(loSettings.CSS),@lcFile)
      =WriteINIString(lcSection,"JS",ALLT(loSettings.JS),@lcFile)
      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst) && Clone values properties of settings
      * loSrc - Source object
      * loDst - Destination object

      loDst.xhtmlS=loSrc.xhtmlS
      loDst.xhtmlE=loSrc.xhtmlE
      loDst.SeeS=loSrc.SeeS
      loDst.SeeE=loSrc.SeeE
      loDst.ByRef=loSrc.ByRef
      loDst.CodeS=loSrc.CodeS
      loDst.CodeE=loSrc.CodeE
      loDst.ExprS=loSrc.ExprS
      loDst.ExprE=loSrc.ExprE

      loDst.noteS=loSrc.noteS
      loDst.noteE=loSrc.noteE
      loDst.stopS=loSrc.stopS
      loDst.stopE=loSrc.stopE
      loDst.questS=loSrc.questS
      loDst.questE=loSrc.questE
      loDst.exclaS=loSrc.exclaS
      loDst.exclaE=loSrc.exclaE
      loDst.infoS=loSrc.infoS
      loDst.infoE=loSrc.infoE

      loDst.Source=loSrc.Source
      loDst.CSS=loSrc.CSS
      loDst.JS=loSrc.JS
   ENDPROC

   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      LOCAL loPDMs,lcLang,lcPath,lcFile,llEn
      loPDMs=EVAL(This.PDMs)
      lcLang=loPDMs.HTMLCLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Open table with HTML's string
      IF !USED(This.AHTML)
         llEn=.T.
         IF !lcLang=="en" AND ;
            loPDMs.OpenTable(This.DataSessionID,lcPath+"_diamp\HTML_"+lcLang+".dbf",This.AHTML,"NOUPDATE AGAIN")=0
            SELE (This.AHTML)
            SET ORDER TO "I01"
            llEn=.F.
         ENDIF

         IF llEn
            CREATE CURSOR (This.AHTML) (XX000 I, XX001 M)
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Propval, "Property Values")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Remarks, "Remarks")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Example, "Example")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_SeeAlso, "See Also")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Property, "Property")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Note, "Note")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Return, "Return")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Params, "Parameters")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Appliesto, "Applies to")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Method, "Method")

            SELE (This.AHTML)
            INDEX ON XX000 TAG I01
         ENDIF
      ENDIF

      * Open table with META Data
      IF !EMPTY(loSetting.Source)
         This.Alias=SYS(2015)
         RETURN loPDMs.OpenTable(This.DataSessionID,IIF(AT("\\",loSetting.Source)>0 OR AT(":",loSetting.Source)>0,"",ExtractPathFromFile(EVAL(This.PDM+".PDM_File")))+loSetting.Source,This.Alias,"NOUPDATE")=0
      ENDIF
      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources() && Close other source
      IF USED(This.Alias)
         USE IN (This.Alias)
      ENDIF
      RETURN .T.
   ENDPROC

   PROCEDURE InitResources(loSetting)
      * loSetting - Object of settings
      =DODEFAULT(@loSetting) && Voln pvodn metody

      LOCAL lcOut,loPDM
      loPDM=EVAL(This.PDM)

      =loPDM.AddFileToRepository(This.MainPath+"_diamp\res\excla.gif","","",@lcOut)
      This.aImgs(PI_img_Excla)=lcOut
    
      =loPDM.AddFileToRepository(This.MainPath+"_diamp\res\info.gif","","",@lcOut)
      This.aImgs(PI_img_Info)=lcOut

      =loPDM.AddFileToRepository(This.MainPath+"_diamp\res\quest.gif","","",@lcOut)
      This.aImgs(PI_img_Quest)=lcOut

      =loPDM.AddFileToRepository(This.MainPath+"_diamp\res\stop.gif","","",@lcOut)
      This.aImgs(PI_img_Stop)=lcOut

      RETURN .T.
   ENDPROC


   PROCEDURE QuickAnalyse(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      LOCAL loPDMs,lcFile,lcFileX,lcClass,lcPEM
      loPDMs=EVAL(This.PDMs)

      IF ISNULL(This.oParser)
         This.oParser=CREATEOBJECT("__DIAMP_PDM")
      ENDIF

      This.oParser.PI=This
      This.Setting=loSetting

      SELE (This.Alias)
      STORE loPar.File TO lcFile,lcFileX
      LOCATE FOR UPPER(CLASSLOC)==UPPER(lcFileX)
      IF !FOUND()
          lcFileX=ExtractFileFromFile(lcFileX)
          LOCATE FOR UPPER(CLASSLOC)==UPPER(lcFileX)
      ENDIF
      * read only methods
      SCAN FOR UPPER(CLASSLOC)==UPPER(lcFileX) AND TYPE="M"  REST
           IF EMPTY(CLASS)
              lcClass=""
              lcPEM=OBJNAME
           ELSE
              lcClass=CLASS+"."+OBJNAME
              lcPEM=SUBS(lcClass,RAT(".",lcClass,1)+1)
              lcClass=LEFT(lcClass,RAT(".",lcClass,1)-1)
           ENDIF
           
           =This.oParser.GetAllSee(@lcFile,@lcClass,@lcPEM,HTML)
           SELE (This.Alias)
      ENDSCAN
      This.oParser.PI=.NULL.
      This.Setting=.NULL.

      RETURN .T.
   ENDPROC

ENDDEFINE

****************************************************************
DEFINE CLASS _DIAMP_PDM_MD_par AS _pdm_PlugIn_Parameter && Settings for plug-in
   Name="_DIAMP_PDM_MD_par"
   OK=.F.
   DIME aCSS(1),aJS(1)
 
   xhtmlS="<xhtml>"
   xhtmlE="</xhtml>"
   SeeS="<see>"
   SeeE="</see>"
   ByRef="ByRef"
   CodeS="<code>"
   CodeE="</code>"
   ExprS="<expr>"
   ExprE="</expr>"


   noteS="<note>"
   noteE="</note>"
   stopS="<noteS>"
   stopE="</noteS>"
   questS="<noteQ>"
   questE="</noteQ>"
   exclaS="<noteE>"
   exclaE="</noteE>"
   infoS="<noteI>"
   infoE="</noteI>"

   Source="" && Table with meta code for methods/procedures
   CSS="diamp_pdm_md.css" && Relative to diamp_pdm.fxp
   JS="diamp_pdm_md.js" && Relative to diamp_pdm.fxp

   _CSS="" && Relative to ....
   _JS="" && 

ENDDEFINE

