LPARAM lcFile,loDump,lcParam

**************************************************************************
** Program name: dumpfll.PRG
** Version: 0.0.2
** Create date: 2005-01-23
** Description: Dump fll/dll informations from file
** Author: Martin Jindra
** E-mail: martin.jindra@egservis.cz
** CP: 1250

CLEAR
IF PCOUNT()<1 OR TYPE("lcFile")#"C"
*   ?"Parameter panic"
ENDIF

#INCLUDE "dumpfll.h"
LOCAL lihFile,liPEAddr,lcData,liz,lii,liy,liStart,;
      loObj,loData,loText,loED,lorData,loExport,loImport,loIT,loDumpX,llOrdinalImport,loDataX
LOCAL ARRAY laData(16)


loDump=CREATEOBJECT("_DumpFLL")

laData(1)="EXPORT" &&           0   // Export Directory
laData(2)="IMPORT" &&           1   // Import Directory
laData(3)="RESOURCE" &&         2   // Resource Directory
laData(4)="EXCEPTION" &&        3   // Exception Directory
laData(5)="SECURITY" &&         4   // Security Directory
laData(6)="BASERELOC" &&        5   // Base Relocation Table
laData(7)="DEBUG" &&            6   // Debug Directory
*laData(8)="COPYRIGHT" &&        7   // (X86 usage)
laData(8)="ARCHITECTURE" &&     7   // Architecture Specific Data
laData(9)="GLOBALPTR" &&        8   // RVA of GP
laData(10)="TLS" &&              9   // TLS Directory
laData(11)="LOAD_CONFIG" &&     10   // Load Configuration Directory
laData(12)="BOUND_IMPORT" &&    11   // Bound Import Directory in headers
laData(13)="IAT" &&             12   // Import Address Table
laData(14)="DELAY_IMPORT" &&    13   // Delay Load Import Descriptors
laData(15)="COM_DESCRIPTOR" &&  14   // COM Runtime descriptor
laData(16)="" &&  15   // 



lihFile=FOPEN(lcFile,0)

IF lihFile<=0
*   ?STRTRAN("Cannot open file %File%","%File%",lcFile)
   RETURN .F.
ENDIF


=FSEEK(lihFile,0x3C) && Locate adress of PE header
liPEAddr=C4ToI(FREAD(lihFile,4))

*?liPEAddr,TRANSFORM(liPEAddr,"@0")
=FSEEK(lihFile,liPEAddr) && Skip to _IMAGE_OPTIONAL_HEADER64


*Signature"
loDump.cSignature=NullTermined(FREAD(lihFile,4))

* IMAGE_FILE_HEADER
loDump.iMachine=C2ToI(FREAD(lihFile,2))
loDump.iNumberOfSections=C2ToI(FREAD(lihFile,2))
loDump.iTimeDateStamp=C4ToI(FREAD(lihFile,4))
loDump.iPointerToSymbolTable=C4ToI(FREAD(lihFile,4))
loDump.iNumberOfSymbols=C4ToI(FREAD(lihFile,4))
loDump.iSizeOfOptionalHeader=C2ToI(FREAD(lihFile,2))
loDump.iCharacteristics=C2ToI(FREAD(lihFile,2))



* IMAGE_OPTIONAL_HEADER
loDump.iMagic=C2ToI(FREAD(lihFile,2))
loDump.iMajorLinkerVersion=ASC(FREAD(lihFile,1))
loDump.iMinorLinkerVersion=ASC(FREAD(lihFile,1))
loDump.iSizeOfCode=C4ToI(FREAD(lihFile,4))
loDump.iSizeOfInitializedData=C4ToI(FREAD(lihFile,4))
loDump.iSizeOfUninitializedData=C4ToI(FREAD(lihFile,4))
loDump.iAddressOfEntryPoint=C4ToI(FREAD(lihFile,4))
loDump.iBaseOfCode=C4ToI(FREAD(lihFile,4))
loDump.iBaseOfData=C4ToI(FREAD(lihFile,4))
loDump.iImageBase=C4ToI(FREAD(lihFile,4))
loDump.iSectionAlignment=C4ToI(FREAD(lihFile,4))
loDump.iFileAlignment=C4ToI(FREAD(lihFile,4))
loDump.iMajorOperatingSystemVersion=C2ToI(FREAD(lihFile,2))
loDump.iMinorOperatingSystemVersion=C2ToI(FREAD(lihFile,2))
loDump.iMajorImageVersion=C2ToI(FREAD(lihFile,2))
loDump.iMinorImageVersion=C2ToI(FREAD(lihFile,2))
loDump.iMajorSubsystemVersion=C2ToI(FREAD(lihFile,2))
loDump.iMinorSubsystemVersion=C2ToI(FREAD(lihFile,2))
loDump.iWin32VersionValue=C4ToI(FREAD(lihFile,4))
loDump.iSizeOfImage=C4ToI(FREAD(lihFile,4))
loDump.iSizeOfHeaders=C4ToI(FREAD(lihFile,4))
loDump.iCheckSum=C4ToI(FREAD(lihFile,4))
loDump.iSubsystem=C2ToI(FREAD(lihFile,2))
loDump.iDllCharacteristics=C2ToI(FREAD(lihFile,2))
loDump.iSizeOfStackReserve=C4ToI(FREAD(lihFile,4))
loDump.iSizeOfStackCommit=C4ToI(FREAD(lihFile,4))
loDump.iSizeOfHeapReserve=C4ToI(FREAD(lihFile,4))
loDump.iSizeOfHeapCommit=C4ToI(FREAD(lihFile,4))
loDump.iLoaderFlags=C4ToI(FREAD(lihFile,4))
loDump.iNumberOfRvaAndSizes=C4ToI(FREAD(lihFile,4))
*!*	  IMAGE_DATA_DIRECTORY DataDirectory[IMAGE_NUMBEROF_DIRECTORY_ENTRIES];



*_IMAGE_DATA_DIRECTORY
=loDump.Init_DataDirectory(loDump.iNumberOfRvaAndSizes)

FOR lii=1 TO loDump.iNumberOfRvaAndSizes
    loObj=loDump.aDataDirectory(lii)
    loObj.cName=laData(lii)
    loObj.iVirtualAddress=C4ToI(FREAD(lihFile,4))
    loObj.iSize=C4ToI(FREAD(lihFile,4))
NEXT


** Zde nsleduje seznam sekc pocet dle liNumberOfSections
*_IMAGE_SECTION_HEADER
=loDump.Init_SectionHeader(loDump.iNumberOfSections)
FOR lii=1 TO loDump.iNumberOfSections
    loObj=loDump.aSectionHeader(lii)
    loObj._PointerToRawData=FSEEK(lihFile,0,1)
    loObj.cName=NullTermined(FREAD(lihFile,8))
    loObj.iVirtualSize=C4ToI(FREAD(lihFile,4))
    loObj.iVirtualAddress=C4ToI(FREAD(lihFile,4))
    loObj.iSizeOfRawData=C4ToI(FREAD(lihFile,4))
    loObj.iPointerToRawData=C4ToI(FREAD(lihFile,4))
    loObj.iPointerToRelocations=C4ToI(FREAD(lihFile,4))
    loObj.iPointerToLinenumbers=C4ToI(FREAD(lihFile,4))
    loObj.iNumberOfRelocations=C2ToI(FREAD(lihFile,2))
    loObj.iNumberOfLinenumbers=C2ToI(FREAD(lihFile,2))
    loObj.iCharacteristics=C4ToI(FREAD(lihFile,4))
NEXT


* Najdi sekci .text a .data
FOR lii=1 TO loDump.iNumberOfSections
    loObj=loDump.aSectionHeader(lii)
    IF loObj.cName==".text"
       loText=loDump.aSectionHeader(lii)
    ENDIF
    IF loObj.cName==".data"
       loData=loDump.aSectionHeader(lii)
    ENDIF
    IF loObj.cName==".rdata"
       lorData=loDump.aSectionHeader(lii)
    ENDIF
NEXT


* Nati sekci .text a hledej 0xC7 0x06 ?? XX YY YY
* kde XX je cislo vetsi nez vyssi byte VRA .data
* kde YY YY je vyssi word z VRA (liImageBase)
IF EMPTY(lcParam) OR ATC("E",lcParam)>0
   =FSEEK(lihFile,loText.iPointerToRawData)
   lcData=FREAD(lihFile,loText.iSizeOfRawData)

   * najdi vsechny vskyty 0xC7 0x06
   liFoxTable=0
   STORE 1 TO liy,lii
   DO WHILE lii>0
      lii=AT(CHR(0xC7)+CHR(0x06),lcData,liy)

      * nael a zkontroluj ostatn bytes
      IF lii>0 AND ;
         BETWEEN(C4ToI(SUBSTR(lcData,lii+2,4)),loDump.iImageBase+loData.iVirtualAddress,loDump.iImageBase+loData.iVirtualAddress+loData.iSizeOfRawData-1)
         loDump.iFoxTable=C4ToI(SUBSTR(lcData,lii+2,4)) && Pointer to FoxTable
         EXIT
      ENDIF  
      liy=liy+1
   ENDDO

   IF loDump.iFoxTable>0
      * Najdi FoxTable
      =FSEEK(lihFile,loData.iPointerToRawData+ loDump.iFoxTable-loDump.iImageBase-loData.iVirtualAddress)

      * FoxTable
      * dword - 0
      * word - number fll functions
      * dword - pointer to FoxInfo

      loDump.aFoxTable(_aFT_Reserved)=C4ToI(FREAD(lihFile,4))
      loDump.aFoxTable(_aFT_Count)=C2ToI(FREAD(lihFile,2))
      loDump.aFoxTable(_aFT_FoxInfo)=C4ToI(FREAD(lihFile,4))

      IF loDump.aFoxTable(2)>0
         =loDump.Init_FoxInfo(loDump.aFoxTable(_aFT_Count))
         FOR lii=1 TO loDump.aFoxTable(_aFT_Count)
             * sko na pointer FoxInfo (1. buka, n-tho dku)
             liStart=loData.iPointerToRawData+ loDump.aFoxTable(_aFT_FoxInfo)-loDump.iImageBase-loData.iVirtualAddress+(lii-1)*14
             loObj=loDump.aFoxInfo(lii)
             =FSEEK(lihFile,liStart)
             * Nzev funkce - pointer
             loObj.iFuncName=liStart
             STORE C4ToI(FREAD(lihFile,4)) TO liy,loObj.iPointer
             =FSEEK(lihFile,loData.iPointerToRawData+liy-loDump.iImageBase-loData.iVirtualAddress)
             loObj.cFuncName=NullTermined(FREAD(lihFile,256))

             * pointer na funkci
             =FSEEK(lihFile,liStart+4)
             loObj.FPFI=C4ToI(FREAD(lihFile,4))

             * Poet parametr
             =FSEEK(lihFile,liStart+4+4)
             loObj.iParmCount=C2ToL(FREAD(lihFile,2))

             * Seznam typ parametr
             =FSEEK(lihFile,liStart+4+4+2)
             liy=C4ToI(FREAD(lihFile,4))
             =FSEEK(lihFile,loData.iPointerToRawData+ liy-loDump.iImageBase-loData.iVirtualAddress)
             loObj.cParmTypes=NullTermined(FREAD(lihFile,256))
         NEXT
      ENDIF
   ENDIF
ENDIF

IF EMPTY(lcParam) OR ATC("E",lcParam)>0
   *_IMAGE_EXPORT_DIRECTORY
   loExport=loDump.aDataDirectory(1)
   loED=loDump.ExportDirectory

   loDataX=loDump.GetSectionByVRA(loExport.iVirtualAddress)
   IF ISNULL(lodataX)
      ?"Section panic"
      RETURN
   ENDIF

   * Najdi zatek Exportovac tabulky
   liStart=loDataX.iPointerToRawData+ loExport.iVirtualAddress-loDataX.iVirtualAddress
   =FSEEK(lihFile,liStart)

   loED.iCharacteristics=C4ToI(FREAD(lihFile,4))
   loED.iTimeDateStamp=C4ToI(FREAD(lihFile,4))
   loED.iMajorVersion=C2ToI(FREAD(lihFile,2))
   loED.iMinorVersion=C2ToI(FREAD(lihFile,2))

   loED.iName=C4ToI(FREAD(lihFile,4))
   =FSEEK(lihFile,loDataX.iPointerToRawData+ loED.iName-loDataX.iVirtualAddress)
   loED.cName=NullTermined(FREAD(lihFile,256))

   =FSEEK(lihFile,liStart+16)
   loED.iBase=C4ToI(FREAD(lihFile,4))
   loED.iNumberOfFunctions=C4ToI(FREAD(lihFile,4))
   loED.iNumberOfNames=C4ToI(FREAD(lihFile,4))

   =loED.Init_ExportDirectory(loED.iNumberOfFunctions,loED.iNumberOfNames)

   loED.iAddressOfFunctions=C4ToI(FREAD(lihFile,4))
   loED.iAddressOfNames=C4ToI(FREAD(lihFile,4))
   loED.iAddressOfNameOrdinals=C4ToI(FREAD(lihFile,4))

   FOR lii=1 TO loED.iNumberOfFunctions
       =FSEEK(lihFile,loDataX.iPointerToRawData+ loED.iAddressOfFunctions-loDataX.iVirtualAddress+(lii-1)*4)
       loED.aFunctions(lii)=C4ToI(FREAD(lihFile,4))
   NEXT

   FOR lii=1 TO loED.iNumberOfNames
       =FSEEK(lihFile,loDataX.iPointerToRawData+ loED.iAddressOfNames-loDataX.iVirtualAddress+(lii-1)*4)
       liz=C4ToI(FREAD(lihFile,4)) && Ukazatel na string
       =FSEEK(lihFile,loDataX.iPointerToRawData+ liz-loDataX.iVirtualAddress)
       loED.aNames(lii)=NullTermined(FREAD(lihFile,256))
   NEXT

   =FSEEK(lihFile,liStart+36)
   liy=C4ToI(FREAD(lihFile,4))
   liz=0
   FOR lii=1 TO loED.iNumberOfNames
       =FSEEK(lihFile,loDataX.iPointerToRawData+ loED.iAddressOfNameOrdinals-loDataX.iVirtualAddress+(lii-1)*2)
       loED.aNameOrdinals(lii)=C2ToI(FREAD(lihFile,2))
   NEXT
ENDIF


IF EMPTY(lcParam) OR ATC("I",lcParam)>0
   *susp
   *IMAGE_IMPORT_DESCRIPTOR
   loImport=loDump.aDataDirectory(2)

   loDataX=loDump.GetSectionByVRA(loImport.iVirtualAddress)
   IF ISNULL(lodataX)
      ?"Section panic"
      RETURN
   ENDIF


   =loDump.Init_ImportDescriptor(loImport.iSize/20)

   * Najdi zatek Importovac tabulky
   liStart=loDataX.iPointerToRawData+ loImport.iVirtualAddress-loDataX.iVirtualAddress

   FOR lii=1 TO loImport.iSize/20
       =FSEEK(lihFile,liStart+(lii-1)*20)

       loObj=loDump.aImportDescriptor(lii)

       loObj.iOriginalFirstThunk=C4ToI(FREAD(lihFile,4))
       IF loObj.iOriginalFirstThunk=0
          DIME loDump.aImportDescriptor(lii-1)
          EXIT
       ENDIF
       loObj.iTimeDateStamp=C4ToL(FREAD(lihFile,4))
       loObj.iForwarderChain=C4ToL(FREAD(lihFile,4))
       loObj.iName=C4ToI(FREAD(lihFile,4))
       loObj.iFirstThunk=C4ToI(FREAD(lihFile,4))

       =FSEEK(lihFile,loDataX.iPointerToRawData+loObj.iName-loDataX.iVirtualAddress)
       loObj.cName=NullTermined(FREAD(lihFile,256))

       liy=loDataX.iPointerToRawData+loObj.iOriginalFirstThunk-loDataX.iVirtualAddress
       =FSEEK(lihFile,liy)
       liz=1
       DO WHILE liz>0
          liz=C4ToI(FREAD(lihFile,4)) && Ukazatel na ImportByName
          IF liz>0 
             loIT=loObj.Add_ImportByName()
             loIT.iTDPointer=liz
             llOrdinalImport=llOrdinalImport OR BITTEST(loIT.iTDPointer,31)
          ENDIF
       ENDDO

       IF llOrdinalImport
          DO (SYS(16)) WITH FULLPATH(loObj.cName,0),loDumpX,"E"
       ENDIF

       FOR liy=1 TO ALEN(loObj.aImportByName)
           loIT=loObj.aImportByName(liy)
           IF BITTEST(loIT.iTDPointer,31)
              loIT.iHint=BITCLEAR(loIT.iTDPointer,31)
              loIT.cName=loDumpX.ExportDirectory.GetFunctionByHint(loIT.iHint)
           ELSE
              =FSEEK(lihFile,loDataX.iPointerToRawData+loIT.iTDPointer-loDataX.iVirtualAddress)
              loIT.iHint=C2ToI(FREAD(lihFile,2))
              loIT.cName=NullTermined(FREAD(lihFile,256))
           ENDIF


           loIT.iPointer=loObj.iFirstThunk+(liy-1)*4 && C4ToI(FREAD(lihFile,4))
       NEXT
   NEXT
ENDIF

=FCLOSE(lihFile)





********************************
PROCEDURE C4ToI(lcInt)
RETURN ASC(LEFT(m.lcInt,1))+;
       ASC(SUBS(m.lcInt,2,1))*256+;
       ASC(SUBS(m.lcInt,3,1))*65536+;
       ASC(RIGHT(m.lcInt,1))*256*65536
ENDPROC

******************************************************************************************
PROCEDURE C2ToI(lcInt)  && slo v etzcovm tvaru WINAPI 16 bit
RETURN ASC(LEFT(m.lcInt,1))+ASC(RIGHT(m.lcInt,1))*256  && vra slo v decimlnm tvaru
ENDPROC

******************************************************************************************
PROCEDURE C2ToL(lcInt)  && slo v etzcovm tvaru WINAPI 16 bit - signed
LOCAL liVal
liVal=ASC(LEFT(lcInt,1))+ASC(RIGHT(lcInt,1))*256
RETURN IIF(liVal<=0x7FFF,liVal,liVal-(0xFFFF+1))


********************************
PROCEDURE C4ToL(lcLong)  && slo v etzcovm tvaru WINAPI 32 bit - signed
LOCAL liVal
liVal=ASC(LEFT(lcLong,1))+;
                  ASC(SUBS(lcLong,2,1))*256+;
                  ASC(SUBS(lcLong,3,1))*65536+;
                  ASC(RIGHT(lcLong,1))*16777216

RETURN IIF(liVal<=0x7FFFFFFF,liVal,liVal-(0xFFFFFFFF+1))


********************************************************************
PROCEDURE NullTermined(lcChar)
LOCAL lii
lii=AT(CHR(0),m.lcChar) && najdi NULL znak v etzci
RETURN IIF(lii>0,LEFT(m.lcChar,lii-1),m.lcChar) && a oe to, pokud tam je
ENDPROC




DEFINE CLASS _DumpFLL AS Custom
   Name="_DumpFLL"

   cSignature=""

   *IMAGE_FILE_HEADER
   iMachine=0
   iNumberOfSections=0
   iTimeDateStamp=0
   iPointerToSymbolTable=0
   iNumberOfSymbols=0
   iSizeOfOptionalHeader=0
   iCharacteristics=0



   *IMAGE_OPTIONAL_HEADER
   iMagic=0
   iMajorLinkerVersion=0
   iMinorLinkerVersion=0
   iSizeOfCode=0
   iSizeOfInitializedData=0
   iSizeOfUninitializedData=0
   iAddressOfEntryPoint=0
   iBaseOfCode=0
   iBaseOfData=0
   iImageBase=0
   iSectionAlignment=0
   iFileAlignment=0
   iMajorOperatingSystemVersion=0
   iMinorOperatingSystemVersion=0
   iMajorImageVersion=0
   iMinorImageVersion=0
   iMajorSubsystemVersion=0
   iMinorSubsystemVersion=0
   iWin32VersionValue=0
   iSizeOfImage=0
   iSizeOfHeaders=0
   iCheckSum=0
   iSubsystem=0
   iDllCharacteristics=0
   iSizeOfStackReserve=0
   iSizeOfStackCommit=0
   iSizeOfHeapReserve=0
   iSizeOfHeapCommit=0
   iLoaderFlags=0
   iNumberOfRvaAndSizes=0

   *_IMAGE_DATA_DIRECTORY
   DIME aDataDirectory(1,2)

   *_IMAGE_SECTION_HEADER
   DIME aSectionHeader(1)


   * FoxTable
   iFoxTable=0 && Pointer to FoxTable
   DIME aFoxTable(3)

   * FoxInfo
   DIME aFoxInfo(1)

   DIME aImportDescriptor(1)

   ADD OBJECT ExportDirectory AS _ExportDirectory

   PROCEDURE GetSectionByVRA(liVRA)
      * liVRA -
      LOCAL lii,loObj
      FOR lii=1 TO This.iNumberOfSections
          loObj=This.aSectionHeader(lii)
          IF BETWEEN(liVRA,loObj.iVirtualAddress,loObj.iVirtualAddress+loObj.iVirtualSize)
             RETURN loObj
          ENDIF
      NEXT
      RETURN .NULL.
   ENDPROC

   PROCEDURE Init_DataDirectory(liCount)
      * liCount - 
      LOCAL lii
      IF m.liCount=0
         RETURN
      ENDIF
      DIME This.aDataDirectory(m.liCount)
      FOR lii=1 TO m.liCount
          This.aDataDirectory(m.lii)=CREATEOBJECT("_DataDirectory")
      NEXT
   ENDPROC

   PROCEDURE Init_SectionHeader(liCount)
      * liCount - 
      LOCAL lii
      IF m.liCount=0
         RETURN
      ENDIF
      DIME This.aSectionHeader(m.liCount)
      FOR lii=1 TO m.liCount
          This.aSectionHeader(m.lii)=CREATEOBJECT("_SectionHeader")
      NEXT
   ENDPROC

   PROCEDURE Init_FoxInfo(liCount)
      * liCount - 
      LOCAL lii
      IF m.liCount=0
         RETURN
      ENDIF
      DIME This.aFoxInfo(m.liCount)
      FOR lii=1 TO m.liCount
          This.aFoxInfo(m.lii)=CREATEOBJECT("_FoxInfo")
      NEXT
   ENDPROC


   PROCEDURE Init_ImportDescriptor(liCount)
      * liCount - 
      LOCAL lii
      IF m.liCount=0
         RETURN
      ENDIF
      DIME This.aImportDescriptor(m.liCount)
      FOR lii=1 TO m.liCount
          This.aImportDescriptor(m.lii)=CREATEOBJECT("_ImportDescriptor")
      NEXT
   ENDPROC

ENDDEFINE

DEFINE CLASS _DataDirectory AS Custom
   Name="_DataDirectory"

   cName=""
   iVirtualAddress=0
   iSize=0
ENDDEFINE


DEFINE CLASS _SectionHeader AS Custom
   Name="_SectionHeader"
   cName=""
   iVirtualSize=0
   iVirtualAddress=0
   iSizeOfRawData=0
   iPointerToRawData=0
   iPointerToRelocations=0
   iPointerToLinenumbers=0
   iNumberOfRelocations=0
   iNumberOfLinenumbers=0
   iCharacteristics=0

   _PointerToRawData=0
ENDDEFINE


DEFINE CLASS _FoxInfo AS Custom
   Name="_FoxInfo"
   iPointer=0 && Ukazatel na nzev funkce
   iFuncName=0 && Umstn ukazatele na nzev funkce
   cFuncName=""
   FPFI=0
   iParmCount=0
   cParmTypes=""
ENDDEFINE


DEFINE CLASS _ExportDirectory AS Custom
   Name="_ExportDirectory"

   iCharacteristics=0
   iTimeDateStamp=0
   iMajorVersion=0
   iMinorVersion=0
   iName=0
   cName=""
   iBase=0
   iNumberOfFunctions=0
   iNumberOfNames=0
   iAddressOfFunctions=0
   iAddressOfNames=0
   iAddressOfNameOrdinals=0

   DIMENSION aFunctions(1), aNames(1), aNameOrdinals(1)

   PROCEDURE Init_ExportDirectory(liCount,liCount2)
      * liCount - 
      * liCount2 - 
      IF m.liCount=0 OR m.liCount2=0
         RETURN
      ENDIF
      DIMENSION This.aFunctions(m.liCount), This.aNames(m.liCount2), This.aNameOrdinals(m.liCount2)
   ENDPROC

   PROCEDURE GetFunctionByHint(liHint)
      LOCAL lii
      lii=ASCAN(This.aNameOrdinals,liHint-This.iBase)
      RETURN IIF(lii>0,This.aNames(lii),"")
   ENDPROC
ENDDEFINE


DEFINE CLASS _ImportDescriptor AS Custom
   Name="_ImportDescriptor"

   iOriginalFirstThunk=0
   iTimeDateStamp=0
   iForwarderChain=0
   iName=0
   cName=""
   iFirstThunk=0

   iImportByName=0
   DIME aImportByName(1)


   PROCEDURE Add_ImportByName()
      This.iImportByName=This.iImportByName+1
      DIMENSION This.aImportByName(m.This.iImportByName)
      This.aImportByName(m.This.iImportByName)=CREATEOBJECT("_ImportByName")
      RETURN This.aImportByName(m.This.iImportByName)
   ENDPROC

ENDDEFINE

DEFINE CLASS _ImportByName AS Custom
   Name="_ImportByName"

   iTDPointer=0
   iPointer=0
   iHint=0
   cName=""
ENDDEFINE



**************************************************************************************************************




**************************
*!*	typedef struct _IMAGE_NT_HEADERS {
*!*	  DWORD Signature;
*!*	  IMAGE_FILE_HEADER FileHeader;
*!*	  IMAGE_OPTIONAL_HEADER OptionalHeader;
*!*	} IMAGE_NT_HEADERS, *PIMAGE_NT_HEADERS;



*!*	typedef struct _IMAGE_FILE_HEADER {
*!*	  WORD Machine;
*!*	  WORD NumberOfSections;
*!*	  DWORD TimeDateStamp;
*!*	  DWORD PointerToSymbolTable;
*!*	  DWORD NumberOfSymbols;
*!*	  WORD SizeOfOptionalHeader;
*!*	  WORD Characteristics;
*!*	} IMAGE_FILE_HEADER, *PIMAGE_FILE_HEADER;



*!*	typedef struct _IMAGE_OPTIONAL_HEADER {
*!*	  WORD    Magic;
*!*	  BYTE    MajorLinkerVersion;
*!*	  BYTE    MinorLinkerVersion; (4)
*!*	  DWORD   SizeOfCode;
*!*	  DWORD   SizeOfInitializedData;
*!*	  DWORD   SizeOfUninitializedData;
*!*	  DWORD   AddressOfEntryPoint;
*!*	  DWORD   BaseOfCode;
*!*	  DWORD   BaseOfData;
*!*	  DWORD   ImageBase;
*!*	  DWORD   SectionAlignment;
*!*	  DWORD   FileAlignment; (36)
*!*	  WORD    MajorOperatingSystemVersion;
*!*	  WORD    MinorOperatingSystemVersion;
*!*	  WORD    MajorImageVersion;
*!*	  WORD    MinorImageVersion;
*!*	  WORD    MajorSubsystemVersion;
*!*	  WORD    MinorSubsystemVersion; (12)
*!*	  DWORD   Win32VersionValue;
*!*	  DWORD   SizeOfImage;
*!*	  DWORD   SizeOfHeaders;
*!*	  DWORD   CheckSum; (16)
*!*	  WORD    Subsystem;
*!*	  WORD    DllCharacteristics; (4)
*!*	  DWORD   SizeOfStackReserve;
*!*	  DWORD   SizeOfStackCommit;
*!*	  DWORD   SizeOfHeapReserve;
*!*	  DWORD   SizeOfHeapCommit;
*!*	  DWORD   LoaderFlags;
*!*	  DWORD   NumberOfRvaAndSizes; (24)
*!*	  IMAGE_DATA_DIRECTORY DataDirectory[IMAGE_NUMBEROF_DIRECTORY_ENTRIES];
*!*	} IMAGE_OPTIONAL_HEADER, *PIMAGE_OPTIONAL_HEADER;



*!*	typedef struct _IMAGE_DATA_DIRECTORY {
*!*	  DWORD   VirtualAddress;
*!*	  DWORD   Size;
*!*	} IMAGE_DATA_DIRECTORY, *PIMAGE_DATA_DIRECTORY;




*!*	#define IMAGE_DIRECTORY_ENTRY_EXPORT          0   // Export Directory
*!*	#define IMAGE_DIRECTORY_ENTRY_IMPORT          1   // Import Directory
*!*	#define IMAGE_DIRECTORY_ENTRY_RESOURCE        2   // Resource Directory
*!*	#define IMAGE_DIRECTORY_ENTRY_EXCEPTION       3   // Exception Directory
*!*	#define IMAGE_DIRECTORY_ENTRY_SECURITY        4   // Security Directory
*!*	#define IMAGE_DIRECTORY_ENTRY_BASERELOC       5   // Base Relocation Table
*!*	#define IMAGE_DIRECTORY_ENTRY_DEBUG           6   // Debug Directory
*!*	//      IMAGE_DIRECTORY_ENTRY_COPYRIGHT       7   // (X86 usage)
*!*	#define IMAGE_DIRECTORY_ENTRY_ARCHITECTURE    7   // Architecture Specific Data
*!*	#define IMAGE_DIRECTORY_ENTRY_GLOBALPTR       8   // RVA of GP
*!*	#define IMAGE_DIRECTORY_ENTRY_TLS             9   // TLS Directory
*!*	#define IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG    10   // Load Configuration Directory
*!*	#define IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT   11   // Bound Import Directory in headers
*!*	#define IMAGE_DIRECTORY_ENTRY_IAT            12   // Import Address Table
*!*	#define IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT   13   // Delay Load Import Descriptors
*!*	#define IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR 14   // COM Runtime descriptor




*!*	typedef struct _IMAGE_SECTION_HEADER {
*!*	  BYTE    Name[IMAGE_SIZEOF_SHORT_NAME]; 8 bytes
*!*	  union {
*!*	      DWORD   PhysicalAddress;
*!*	      DWORD   VirtualSize;
*!*	  } Misc;
*!*	  DWORD   VirtualAddress;
*!*	  DWORD   SizeOfRawData;
*!*	  DWORD   PointerToRawData;
*!*	  DWORD   PointerToRelocations;
*!*	  DWORD   PointerToLinenumbers;
*!*	  WORD    NumberOfRelocations;
*!*	  WORD    NumberOfLinenumbers;
*!*	  DWORD   Characteristics;
*!*	} IMAGE_SECTION_HEADER, *PIMAGE_SECTION_HEADER;



*!*    typedef struct _IMAGE_EXPORT_DIRECTORY {
*!*        DWORD   Characteristics;
*!*        DWORD   TimeDateStamp;
*!*        WORD    MajorVersion;
*!*        WORD    MinorVersion;
*!*        DWORD   Name;
*!*        DWORD   Base;
*!*        DWORD   NumberOfFunctions;
*!*        DWORD   NumberOfNames;
*!*        DWORD   AddressOfFunctions;     // RVA from base of image
*!*        DWORD   AddressOfNames;         // RVA from base of image
*!*        DWORD   AddressOfNameOrdinals;  // RVA from base of image
*!*    } IMAGE_EXPORT_DIRECTORY, *PIMAGE_EXPORT_DIRECTORY;

*!*    *IMAGE_IMPORT_DESCRIPTOR
*!*    //
*!*    // Import Format
*!*    //



*!*	typedef struct _IMAGE_IMPORT_DESCRIPTOR {
*!*	    union {
*!*	**        DWORD   Characteristics;            // 0 for terminating null import descriptor
*!*	        DWORD   OriginalFirstThunk;         // RVA to original unbound IAT (PIMAGE_THUNK_DATA)
*!*	    };
*!*	    DWORD   TimeDateStamp;                  // 0 if not bound,
*!*	                                            // -1 if bound, and real date\time stamp
*!*	                                            //     in IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT (new BIND)
*!*	                                            // O.W. date/time stamp of DLL bound to (Old BIND)

*!*	    DWORD   ForwarderChain;                 // -1 if no forwarders
*!*	    DWORD   Name;
*!*	    DWORD   FirstThunk;                     // RVA to IAT (if bound this IAT has actual addresses)
*!*	} IMAGE_IMPORT_DESCRIPTOR;
*!*	typedef IMAGE_IMPORT_DESCRIPTOR UNALIGNED *PIMAGE_IMPORT_DESCRIPTOR;











*!*    typedef struct _IMAGE_IMPORT_BY_NAME {
*!*        WORD    Hint;
*!*        BYTE    Name[1];
*!*    } IMAGE_IMPORT_BY_NAME, *PIMAGE_IMPORT_BY_NAME;

*!*    typedef struct _IMAGE_THUNK_DATA64 {
*!*        union {
*!*            PBYTE  ForwarderString;
*!*            PDWORD Function;
*!*            ULONGLONG Ordinal;
*!*            PIMAGE_IMPORT_BY_NAME  AddressOfData;
*!*        } u1;
*!*    } IMAGE_THUNK_DATA64;
*!*    typedef IMAGE_THUNK_DATA64 * PIMAGE_THUNK_DATA64;


*!*    typedef struct _IMAGE_THUNK_DATA32 {
*!*        union {
*!*            PBYTE  ForwarderString;
*!*            PDWORD Function;
*!*            DWORD Ordinal;
*!*            PIMAGE_IMPORT_BY_NAME  AddressOfData;
*!*        } u1;
*!*    } IMAGE_THUNK_DATA32;
*!*    typedef IMAGE_THUNK_DATA32 * PIMAGE_THUNK_DATA32;



*!*	// The FoxInfo structure contains the descriptions of the functions
*!*	// contained in the library.
*!*	typedef struct {
*!*		char FAR *	funcName;		/* Function name (all caps)				*/
*!*	    FPFI        function;       /* Actual function address              */
*!*		short		parmCount;		/* # parameters specified or a flag value */
*!*		char FAR *	parmTypes;		/* Parameter list description			*/
*!*	} FoxInfo;

* DWORD 
* DWORD
* WORD
* DWORD

*19x

*!*	typedef struct _FoxTable {
*!*		struct _FoxTable FAR *nextLibrary;	/* Linked list of libraries		*/
*!*		short infoCount;			/* # of functions in this library		*/
*!*		FoxInfo FAR *infoPtr;		/* Function list						*/
*!*	} FoxTable;


