**************************************************************************
** Nzev programu: String.PRG
** Verze: 0.0.4
** Datum vytvoen: 2001-01-05
** Popis: Procedury pro prci s etzci
** Autor: Martin Jindra
** E-mail: martin.jindra@egservis.cz
**

#INCLUDE "main.h"


************************************************************************************
** Vrt pozici CRLF v etzci od urit pozice (vyhledv zleva)
************************************************************************************
PROCEDURE AT_CRLF(lcSource,liStart,liEnd)
* @lcSource - Zdrojov etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn
liEnd=IIF(PCOUNT()=4,m.liEnd,LEN(m.lcSource))
DO WHILE m.liStart<=m.liEnd AND !SUBS(m.lcSource,m.liStart,2)==CRLF
   liStart=m.liStart+1 && Inkrementuj ta
ENDDO
RETURN IIF(m.liStart>m.liEnd,0,;
       IIF(!SUBS(m.lcSource,m.liStart,2)==CRLF,0,m.liStart)) && Vra poten pozici CRLF
ENDPROC

************************************************************************************
** Vrt pozici CRLF v etzci od urit pozice (vyhledv zprava)
************************************************************************************
PROCEDURE RAT_CRLF(lcSource,liStart,liEnd)
* @lcSource - Zdrojov etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn
liEnd=IIF(PCOUNT()=3,m.liEnd,1)
DO WHILE m.liStart>=m.liEnd AND !SUBS(m.lcSource,m.liStart,2)==CRLF
   liStart=m.liStart-1 && Dekrementuj ta
ENDDO
RETURN IIF(m.liStart<m.liEnd,0,;
       IIF(!SUBS(m.lcSource,m.liStart,2)==CRLF,0,m.liStart)) && Vra poten pozici CRLF
ENDPROC

************************************************************************************
** Vrt pozici CR v etzci od urit pozice (vyhledv zleva)
************************************************************************************
PROCEDURE AT_CR(lcSource,liStart,liEnd)
* @lcSource - Zdrojov etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn
liEnd=IIF(PCOUNT()=3,m.liEnd,LEN(m.lcSource))
DO WHILE m.liStart<=m.liEnd AND !SUBS(m.lcSource,m.liStart,1)=CHR(13)
   liStart=m.liStart+1 && Inkrementuj ta
ENDDO
RETURN IIF(m.liStart>m.liEnd,0,;
       IIF(!SUBS(m.lcSource,m.liStart,1)=CHR(13),0,m.liStart)) && Vra poten pozici CR
ENDPROC

************************************************************************************
** Vrt pozici CR v etzci od urit pozice (vyhledv zprava)
************************************************************************************
PROCEDURE RAT_CR(lcSource,liStart,liEnd)
* @lcSource - Zdrojov etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn
liEnd=IIF(PCOUNT()=3,m.liEnd,1)
DO WHILE m.liStart>=m.liEnd AND !SUBS(m.lcSource,m.liStart,1)=CHR(13)
   liStart=m.liStart-1 && Dekrementuj ta
ENDDO
RETURN IIF(m.liStart<m.liEnd,0,;
       IIF(!SUBS(m.lcSource,m.liStart,1)=CHR(13),0,m.liStart)) && Vra poten pozici CR
ENDPROC

************************************************************************************
** Vrt pozici znaku, kter nen mezera i tabeltor, v etzci od urit pozice (vyhledv zleva)
************************************************************************************
PROCEDURE AT_NonSpace(lcSource,liStart,liEnd)
* @lcSource - Zdrojov etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn
liEnd=IIF(PCOUNT()=3,m.liEnd,LEN(m.lcSource))
DO WHILE m.liStart<=m.liEnd AND (SUBS(m.lcSource,m.liStart,1)=" " OR  SUBS(m.lcSource,m.liStart,1)=CHR(9))
   liStart=m.liStart+1 && Inkrementuj ta
ENDDO
RETURN IIF(m.liStart>m.liEnd,0,;
       IIF(SUBS(m.lcSource,m.liStart,1)==" " OR SUBS(m.lcSource,m.liStart,1)==CHR(9),0,m.liStart)) && Vra poten pozici 
ENDPROC

************************************************************************************
** Vrt pozici znaku, kter nen mezera i tabeltor, v etzci od urit pozice (vyhledv zprava)
************************************************************************************
PROCEDURE RAT_NonSpace(lcSource,liStart,liEnd)
* @lcSource - Zdrojov etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn
LOCAL liLen
liEnd=IIF(PCOUNT()=3,m.liEnd,1)
DO WHILE m.liStart>=m.liEnd AND  (SUBS(m.lcSource,m.liStart,1)=" " OR  SUBS(m.lcSource,m.liStart,1)=CHR(9))
   liStart=m.liStart-1 && Dekrementuj ta
ENDDO
RETURN IIF(m.liStart<m.liEnd,0,;
       IIF(SUBS(m.lcSource,m.liStart,1)==" " OR SUBS(m.lcSource,m.liStart,1)==CHR(9),0,m.liStart)) && Vra poten pozici
ENDPROC

************************************************************************************
** Vrt pozici znaku, kter je mezera i tabeltor, v etzci od urit pozice (vyhledv zleva)
************************************************************************************
PROCEDURE AT_Space(lcSource,liStart,liEnd)
* @lcSource - Zdrojov etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn
liEnd=IIF(PCOUNT()=3,m.liEnd,LEN(m.lcSource))
DO WHILE m.liStart<=m.liEnd AND !SUBS(m.lcSource,m.liStart,1)=" " AND  !SUBS(m.lcSource,m.liStart,1)=CHR(9)
   liStart=m.liStart+1 && Inkrementuj ta
ENDDO
RETURN IIF(m.liStart>m.liEnd,0,;
       IIF(SUBS(m.lcSource,m.liStart,1)==" " OR SUBS(m.lcSource,m.liStart,1)==CHR(9),m.liStart,0)) && Vra poten pozici
ENDPROC

************************************************************************************
** Vrt pozici znaku, kter je mezera i tabeltor, v etzci od urit pozice (vyhledv zprava)
************************************************************************************
PROCEDURE RAT_Space(lcSource,liStart,liEnd)
* @lcSource - Zdrojov etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn

LOCAL liLen
liEnd=IIF(PCOUNT()=3,m.liEnd,1)
DO WHILE m.liStart>=m.liEnd AND !SUBS(m.lcSource,m.liStart,1)=" " AND !SUBS(m.lcSource,m.liStart,1)=CHR(9)
   liStart=m.liStart-1 && Dekrementuj ta
ENDDO
RETURN IIF(m.liStart<m.liEnd,0,;
       IIF(SUBS(m.lcSource,m.liStart,1)==" " OR SUBS(m.lcSource,m.liStart,1)==CHR(9),m.liStart,0)) && Vra poten pozici
ENDPROC


************************************************************************************
** Vrt pozici znaku, kter nen mezera i tabeltor, v etzci od urit pozice
** (vyhledv zleva), s tm, e ignoruje znaky SPACE a TAB
************************************************************************************
PROCEDURE AT_Word(lcSource,liStart,liEnd)
* @lcSource - Zdrojov etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn

liEnd=IIF(PCOUNT()=3,m.liEnd,LEN(m.lcSource))
DO WHILE liStart<=m.liEnd AND !SUBS(m.lcSource,m.liStart,1)=" " AND  !SUBS(m.lcSource,m.liStart,1)=CHR(9)
   liStart=m.liStart+1 && Inkrementuj ta
ENDDO
liStart=IIF(m.liStart>m.liEnd,0,;
        IIF(SUBS(m.lcSource,m.liStart,1)==" " OR SUBS(m.lcSource,m.liStart,1)==CHR(9),m.liStart,0)) && Vra poten pozici

IF m.liStart>0
   liEnd=IIF(PCOUNT()=3,m.liEnd,LEN(m.lcSource))
   DO WHILE m.liStart<=m.liEnd AND (SUBS(m.lcSource,m.liStart,1)=" " OR  SUBS(m.lcSource,m.liStart,1)=CHR(9))
      liStart=m.liStart+1 && Inkrementuj ta
   ENDDO
   RETURN IIF(m.liStart>m.liEnd,0,;
          IIF(SUBS(m.lcSource,m.liStart,1)==" " OR SUBS(m.lcSource,m.liStart,1)==CHR(9),0,m.liStart)) && Vra poten pozici
ELSE
   RETURN 0
ENDIF
ENDPROC


************************************************************************************
** Vrt pozici etzce v etzci od urit pozice (vyhledv zleva)
************************************************************************************
PROCEDURE AT_Ex(lcSource,lcString,liStart,liEnd)
* @lcSource - Zdrojov etzec
* @lcString - Hledan etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn
LOCAL liLen
liLen=LEN(m.lcString)
liEnd=IIF(PCOUNT()=4,m.liEnd,LEN(m.lcSource))
DO WHILE m.liStart<=m.liEnd AND !SUBS(m.lcSource,m.liStart,m.liLen)==m.lcString
   liStart=m.liStart+1 && Inkrementuj ta
ENDDO
RETURN IIF(m.liStart>m.liEnd,0,;
       IIF(!SUBS(m.lcSource,m.liStart,m.liLen)==m.lcString,0,m.liStart)) && Vra poten pozici
ENDPROC

************************************************************************************
** Vrt pozici etzce v etzci od urit pozice (vyhledv zprava)
************************************************************************************
PROCEDURE RAT_Ex(lcSource,lcString,liStart,liEnd)
* @lcSource - Zdrojov etzec
* @lcString - Hledan etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn
LOCAL liLen
liLen=LEN(m.lcString)
liEnd=IIF(PCOUNT()=4,m.liEnd,1)
DO WHILE m.liStart>=m.liEnd AND !SUBS(m.lcSource,m.liStart,m.liLen)==m.lcString
   liStart=m.liStart-1 && Dekrementuj ta
ENDDO
RETURN IIF(m.liStart<m.liEnd,0,;
       IIF(!SUBS(m.lcSource,m.liStart,m.liLen)==m.lcString,0,m.liStart)) && Vra poten pozici nalezenho etzce
ENDPROC


************************************************************************************
** Vrt pozici etzce v etzci od urit pozice (vyhledv zleva, non Case sensitive)
************************************************************************************
PROCEDURE AT_ExC(lcSource,lcString,liStart,liEnd)
* @lcSource - Zdrojov etzec
* @lcString - Hledan etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn
LOCAL liLen
liLen=LEN(m.lcString)
lcString=LOWER(m.lcString)
liEnd=IIF(PCOUNT()=4,m.liEnd,LEN(m.lcSource))
DO WHILE m.liStart<=m.liEnd AND !LOWER(SUBS(m.lcSource,m.liStart,m.liLen))==m.lcString
   liStart=m.liStart+1 && Inkrementuj ta
ENDDO
RETURN IIF(m.liStart>m.liEnd,0,;
       IIF(!LOWER(SUBS(m.lcSource,m.liStart,m.liLen))==m.lcString,0,m.liStart)) && Vra poten pozici nelzenho etzce
ENDPROC

************************************************************************************
** Vrt pozici etzce v etzci od urit pozice (vyhledv zprava, non Case sensitive)
************************************************************************************
PROCEDURE RAT_ExC(lcSource,lcString,liStart,liEnd)
* @lcSource - Zdrojov etzec
* @lcString - Hledan etzec
* liStart   - Startovac pozice pro hledn
* liEnd     - Konen pozice pro hledn
LOCAL liLen
liLen=LEN(m.lcString)
lcString=LOWER(m.lcString)
DO WHILE m.liStart>=m.liEnd AND !LOWER(SUBS(m.lcSource,m.liStart,m.liLen))==m.lcString
   liStart=m.liStart-1 && Inkrementuj ta
ENDDO
RETURN IIF(m.liStart<m.liEnd,0,;
       IIF(!LOWER(SUBS(m.lcSource,m.liStart,m.liLen))==m.lcString,0,m.liStart)) && Vra poten pozici hledanho etzce
ENDPROC


************************************************************************************
** Vrt konkrtn dek z etzce (bez CRLF)
************************************************************************************
PROCEDURE MLineEx(lcSource,liLine)
* @lcSource - Zdrojov etzec
* liLine    - slo dku je se m nast
LOCAL liEndCRLF,liStartCRLF
IF m.liLine#0 && Pokud to nen 0
   liEndCRLF=AT(CHR(13),m.lcSource,m.liLine) && Nati konec dku
   IF liEndCRLF=0 && Pokud konec nenael (i to se me stt)
      liStartCRLF=IIF(m.liLine=1,1,AT(CHR(13),m.lcSource,m.liLine-1)) && Najdi zatek
      RETURN IIF(m.liLine=1,m.lcSource,IIF(SUBS(m.lcSource,m.liStartCRLF+1,1)=CHR(10),SUBST(m.lcSource,m.liStartCRLF+2),SUBST(m.lcSource,m.liStartCRLF+1))) && Pak to vem pomoc SUBST() do konce
   ELSE
      IF m.liLine=1 && Pokud se jedn o prvn
         RETURN LEFT(m.lcSource,m.liEndCRLF-1) && Pak to vem pomoc LEFT()
      ELSE
         liStartCRLF=AT(CHR(13),m.lcSource,m.liLine-1) && Najdi zatek
         liStartCRLF=m.liStartCRLF+IIF(SUBS(m.lcSource,m.liStartCRLF+1,1)=CHR(10),2,1)
         RETURN SUBST(m.lcSource,m.liStartCRLF,m.liEndCRLF-m.liStartCRLF)
      ENDIF
   ENDIF
ENDIF
RETURN ""
ENDPROC



************************************************************
PROCEDURE AWords(lcRow,lcSep,laWords) && Nate slova do matice
* lcRow   - Zdrojov text
* lcSep   - Oddlova slov
*@laWords - Vstupn matice
LOCAL lii,liCount,lcWord
liCount=0
lcWord=GetWordEx(@m.lcRow,@m.lcSep,1,LEN(m.lcRow))
DO WHILE !EMPTY(m.lcWord)
   liCount=m.liCount+1
   DIME laWords(m.liCount)
   laWords(m.liCount)=m.lcWord
   lcWord=GetWordEx(@m.lcRow,@m.lcSep,1,LEN(m.lcRow))
ENDDO
RETURN m.liCount
ENDPROC

*************************************
* Vrt slovo, ignoruje oddlovae v etzci
*************************************
PROCEDURE GetWordEx(lcSource,lcOdd,liStart,liEnd) &&  && Vrt 1. slovo z etzce, ignoruje slova v oddlovach
*@lcSource - Zdrojov etzec
*@lcOdd    - Oddlova co se m hledat
* liStart  - Startovac pozice pro hledn
* liEnd    - Konen pozice pro hledn

LOCAL liFlag,lcChar,lcPom,llWord,liOld

lcChar=SUBS(m.lcSource,m.liStart,1)
liFlag=IIF(m.lcChar="[",1,;
       IIF(m.lcChar="'",2,;
       IIF(m.lcChar='"',4,;
       IIF(m.lcChar='(',6,0))))

liEnd=IIF(PCOUNT()=4,m.liEnd,LEN(m.lcSource))
liOld=m.liStart

DO WHILE m.liStart<=lm.iEnd
   IF m.liFlag=0 AND ATC(m.lcChar,m.lcOdd)>0
      IF m.llWord
         lcPom=SUBST(m.lcSource,m.liOld,m.liStart-m.liOld)
         lcSource=SUBST(m.lcSource,m.liStart)
         RETURN m.lcPom
      ELSE
         liOld=m.liOld+1
      ENDIF
   ENDIF

   llWord=.T.
   liStart=m.liStart+1 && Inkrementuj ta
   lcChar=SUBS(m.lcSource,m.liStart,1) && Nati dal znak

   liFlag=IIF(m.liFlag=1 AND m.lcChar="]",0,;
          IIF(m.liFlag=2 AND m.lcChar="'",0,;
          IIF(m.liFlag=4 AND m.lcChar='"',0,;
          IIF(m.liFlag=6 AND m.lcChar=')',0,;
          IIF(m.lcChar="[",1,;
          IIF(m.lcChar="'",2,;
          IIF(m.lcChar='"',4,;
          IIF(m.lcChar='(',6,m.liFlag))))))))
          
ENDDO
IF llWord
   lcPom=SUBST(m.lcSource,m.liOld)
   lcSource=""
   RETURN m.lcPom
ELSE
   RETURN "" && Vra, e nic nenael
ENDIF
ENDPROC
